
# Conditional build:
%bcond_with	pam		# PAM authentication support
%bcond_without	logdb		# enable mod_logdb (server-side message logging)
%bcond_with	weaker_crypto	# enable SSLv3

Summary:	Fault-tolerant distributed Jabber/XMPP server
Summary(pl.UTF-8):	Odporny na awarie rozproszony serwer Jabbera/XMPP
Name:		ejabberd
Version:	15.09
Release:	1
License:	GPL
Group:		Applications/Communications
Source0:	http://www.process-one.net/downloads/ejabberd/%{version}/%{name}-%{version}.tgz
# Source0-md5:	616a2fa06064e53ef0130260116dbb68
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Source3:	%{name}.service
Source4:	%{name}.logrotate
#
# Archives created with the ejabberd-pack_deps.sh script (in this repo)
Source10: ejabberd-elixir-20150712.tar.gz
# Source10-md5:	d5d6770c1d4d8e79dc9e9a0e9109bfc8
Source11: ejabberd-esip-20150722.tar.gz
# Source11-md5:	9d41942a114e13af343992f2b70b9102
Source12: ejabberd-goldrush-20150530.tar.gz
# Source12-md5:	d0da4c67a1926e68f6e5ba83fa000dbd
Source13: ejabberd-jiffy-20150831.tar.gz
# Source13-md5:	2175f4219f97b627466fff70d3b7c9e2
Source14: ejabberd-lager-20150812.tar.gz
# Source14-md5:	b054a6a00e18800f60e8a84e9b2d0178
Source15: ejabberd-oauth2-20150928.tar.gz
# Source15-md5:	4f784ea8fc242b980ebd88591b63787d
Source16: ejabberd-p1_cache_tab-20150628.tar.gz
# Source16-md5:	f247d0482084724c72007303606325ec
Source17: ejabberd-p1_iconv-20150624.tar.gz
# Source17-md5:	c1b155bd12750b68eb3b5e1cd30633c0
Source18: ejabberd-p1_mysql-20150929.tar.gz
# Source18-md5:	008681215bfac2ef6e564022fc59d5ea
Source19: ejabberd-p1_pgsql-20150428.tar.gz
# Source19-md5:	276801e6dc862fdd87c2bf75c43022eb
Source20: ejabberd-p1_stringprep-20150204.tar.gz
# Source20-md5:	7bee6c6e233656699d8185739fe4cc42
Source21: ejabberd-p1_stun-20150916.tar.gz
# Source21-md5:	f191e45df97de294cdc854caa9183c1b
Source22: ejabberd-p1_tls-20150803.tar.gz
# Source22-md5:	25f045ce6c07380fb7d1572eecd2ec4f
Source23: ejabberd-p1_utils-20150204.tar.gz
# Source23-md5:	02f75bb69077a30da3ec4337cc00ec02
Source24: ejabberd-p1_xml-20150924.tar.gz
# Source24-md5:	7104125f840d7e20723339a6a4b88ee4
Source25: ejabberd-p1_yaml-20150925.tar.gz
# Source25-md5:	38c6c36acf0ddf7a5d960ab7aa3f7661
Source26: ejabberd-p1_zlib-20150223.tar.gz
# Source26-md5:	38c5ed4af6cde4d2cf21dfc3ba73028d
Source27: ejabberd-rebar_elixir_plugin-20150420.tar.gz
# Source27-md5:	aa115c4fffc7e25fb782da595e0c6fa6
Source28: ejabberd-xmlrpc-20150506.tar.gz
# Source28-md5:	852876d8cc812747c3d8af992491a9f7
#
Patch0:		%{name}-paths.patch
Patch1:		%{name}-config.patch
# not available for 13.10
#Patch2:		%{name}-vcard-access-get.patch
# http://www.dp.uz.gov.ua/o.palij/mod_logdb/patch-mod_logdb-13.12.diff
Patch3:		%{name}-mod_logdb.patch
Patch4:		%{name}-no_sslv3_or_3des.patch
URL:		http://www.ejabberd.im/
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	erlang >= 1:R16B03
BuildRequires:	expat-devel >= 1.95
BuildRequires:	openssl-devel
%if %{with pam}
BuildRequires:	pam-devel
%endif
BuildRequires:	rpmbuild(macros) >= 1.671
BuildRequires:	yaml-devel
BuildRequires:	zlib-devel
BuildRequires:	git-core
Requires(post):	/usr/bin/perl
Requires(post):	jabber-common
Requires(post):	sed >= 4.0
Requires(post):	textutils
Requires(post,preun):	/sbin/chkconfig
Requires(post,preun,postun):	systemd-units >= 38
Requires:	erlang >= 1:R15B01
Requires:	expat >= 1.95
Requires:	rc-scripts
Requires:	systemd-units >= 38
Conflicts:	logrotate < 3.8.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoprovfiles	%{_libdir}/%{name}/priv/lib/

%description
ejabberd is a Free and Open Source fault-tolerant distributed Jabber
server. It is written mostly in Erlang.

%description -l pl.UTF-8
ejabberd to darmowy, z otwartymi źródłami, odporny na awarie
rozproszony serwer Jabbera. Jest napisany w większości w Erlangu.

%package logdb
Summary:	Server-side logging module
Group:		Applications/Communications
Requires:	%{name} = %{version}-%{release}

%description logdb
Server-side logging module.

%prep
%setup -q -a 10 -a 11 -a 12 -a 13 -a 14 -a 15 -a 16 -a 17 -a 18 -a 19 -a 20 -a 21 -a 22 -a 23 -a 24 -a 25 -a 26 -a 27 -a 28
%patch0 -p1
%patch1 -p1
#%%patch2 -p1
%if %{with logdb}
%patch3 -p1
%endif
%if %{without weaker_crypto}
%patch4 -p1
%endif

# Various parts of the build system use 'git describe'
# which returns nonsense on manual builds using the builder script
# and which fails on the PLD builders
# I was not able to locate all 'git describe' invocation, sot let's
# fool them with this dummy repository
unset GIT_DIR GIT_WORK_TREE
git init
git config user.email "dummy@example.com"
git config user.name "Dummy"
git add configure.ac
git commit -a -m "dummy commit"
git tag "%{version}"

%build
unset GIT_DIR GIT_WORK_TREE
%{__aclocal} -I m4
%{__autoconf}
%configure \
	%{?with_pam --enable-pam} \
	--enable-user=jabber \
	--enable-elixir \
	--enable-full-xml \
	--enable-nif \
	--enable-odbc \
	--enable-mysql \
	--enable-pgsql \
	%{?with_pam:--enable-pam} \
	--enable-zlib \
	--enable-json \
	--enable-iconv \
	--enable-lager

touch deps/.got

cd deps/p1_iconv
%configure
cd ../..
cd deps/p1_stringprep
%configure
cd ../..
cd deps/p1_tls
%configure
cd ../..
cd deps/p1_xml
%configure \
	--enable-nif \
	--enable-full-xml
cd ../..
cd deps/p1_yaml
%configure
cd ../..
cd deps/p1_zlib
%configure
cd ../..
cd deps/esip
%configure
cd ../..

%{__make} -j1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/lib/%{name},/etc/{sysconfig,rc.d/init.d}} \
		$RPM_BUILD_ROOT{%{systemdunitdir},%{_sbindir}} \
		$RPM_BUILD_ROOT{/etc/logrotate.d,/var/log/archive/%{name}}

unset GIT_DIR GIT_WORK_TREE

%{__make} install -j1 \
	CHOWN_COMMAND=true \
	O_USER="" \
	G_USER="" \
	DESTDIR=$RPM_BUILD_ROOT

sed -e's,@libdir@,%{_libdir},g' -e 's,@EJABBERD_DOC_PATH@,%{_docdir}/%{name}-%{version}/doc,g' %{SOURCE1} > $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}
install %{SOURCE3} $RPM_BUILD_ROOT%{systemdunitdir}/%{name}.service
install %{SOURCE4} $RPM_BUILD_ROOT/etc/logrotate.d/%{name}

chmod u+rw $RPM_BUILD_ROOT%{_sbindir}/%{name}*

chmod 755 $RPM_BUILD_ROOT%{_libdir}/ejabberd/priv/lib/*.so

rm -rf _doc 2>/dev/null || :
mv $RPM_BUILD_ROOT%{_docdir}/%{name} _doc

touch $RPM_BUILD_ROOT%{_sysconfdir}/jabber/ejabberd.cfg
touch $RPM_BUILD_ROOT/var/lib/ejabberd/.erlang.cookie

%clean
rm -rf $RPM_BUILD_ROOT

%pre
if [ -e /etc/jabber/ejabberd.cfg ] ; then
	%banner -e %{name} <<'EOF'
Old-style /etc/jabber/ejabberd.cfg configuration file exists. You should
consider converting it to the new YAML format. You can do this with the
'ejabberdctl convert_to_yaml' command (ejabberd must be already running).
EOF
fi

%post
if [ -f %{_sysconfdir}/jabber/secret ] ; then
	SECRET="$(cat %{_sysconfdir}/jabber/secret)"
	if [ -n "$SECRET" ] ; then
		echo -n "Updating component authentication secret in ejabberd config file..." >&2
		%{__sed} -i -e "s/@service_secret@/$SECRET/" /etc/jabber/ejabberd.yml
		echo "done" >&2
	fi
fi
/sbin/chkconfig --add ejabberd
if [ -e /var/run/%{name}-upgrade-trigger ] ; then
	# service will be restarted in the postun trigger
	rm -f /var/run/%{name}-upgrade-trigger || :
else
	%service ejabberd restart "ejabberd server"
	%systemd_post %{name}.service
fi

%preun
if [ "$1" = "0" ]; then
	%service ejabberd stop
	/sbin/chkconfig --del ejabberd
fi
%systemd_preun %{name}.service

%postun
%systemd_reload

%triggerprein -- %{name} < 13.10
if [ -e /etc/jabber/ejabberd.cfg ] ; then
	if grep -Eq '^[^%]*access_get' /etc/jabber/ejabberd.cfg ; then
		echo "Your 'ejabberd.cfg' config file seems to use 'access_get' option of mod_vcard" >&2
		echo "this is not supported by this ejabberd version in PLD" >&2
		exit 1
	fi
	rm -f /etc/jabber/ejabberd.yml.rpmnew 2>/dev/null || :
fi
if [ -e /var/lock/subsys/ejabberd ] ; then
	# old init script won't stop ejabberd correctly
	# stop it's all processes here
	# we assume any 'epmd', 'beam', 'beam.smp' or 'heart' process
	# running with uid of jabber is ejabberd process
	pids="$(ps -C "epmd beam beam.smp heart" -o pid=,user= | awk '/jabber/ { print $1 }')" || :
	if [ -n "$pids" ] ; then
		%banner -e %{name} <<'EOF'
Killing all 'epmd, beam, beam.smp, heart' processed owned by the 'jabber' user to make sure old ejabberd is down.

EOF
		kill $pids || :
	fi
fi
touch /var/run/%{name}-upgrade-trigger || :

%triggerpostun -- %{name} < 13.10
# convert old 'NODENAME' in /etc/sysconfig/ejabberd
# to 'ERLANG_NODE' in /etc/jabber/ejabberdctl.cfg
# and move other settings
NODENAME="$(hostname)"
if [ -e /etc/sysconfig/ejabberd ] ; then
	. /etc/sysconfig/ejabberd || :
fi
subst="s/^#ERLANG_NODE=.*/ERLANG_NODE=ejabberd@${NODENAME}/"
if [ "$NODENAME" != "localhost" ] ; then
	%banner -e %{name} <<'EOF'
Configured node name (ejabberd@${NODENAME}) is not at 'localhost'.
– setting INET_DIST_INTERFACE=0.0.0.0 in /etc/jabber/ejabberdctl.cfg.
You should consider tuning that or your firewall configuration.

EOF
	subst="$subst;s/^#INET_DIST_INTERFACE=.*/INET_DIST_INTERFACE=0.0.0.0/"
fi
if [ -n "$ERL_MAX_PORTS" ] ; then
	subst="$subst;s/^#ERL_MAX_PORTS=.*/ERL_MAX_PORTS=${ERL_MAX_PORTS}/"
fi
sed -i -e"$subst" /etc/jabber/ejabberdctl.cfg || :
if [ -e /etc/sysconfig/ejabberd ] ; then
	sed -i.rpmsave \
		-e'/^[#[:space:]]*NODENAME=/d;/^# Node name/d' \
		-e'/^[#[:space:]]*ERL_MAX_PORTS=/d;/^# uncomment this to allow more then 1024 connections/d' \
		-e'/^[#[:space:]]*ERL_FULLSWEEP_AFTER=/d;/^# uncomment this to limit memory usage/d' \
		/etc/sysconfig/ejabberd || :
fi
cp %{_sysconfdir}/jabber/cookie /var/lib/ejabberd/.erlang.cookie || :
chown jabber:jabber /var/lib/ejabberd/.erlang.cookie || :
chmod 400 /var/lib/ejabberd/.erlang.cookie || :
if [ -e /etc/jabber/ejabberd.cfg -a ! -e /etc/jabber/ejabberd.yml.rpmnew ] ; then
	mv /etc/jabber/ejabberd.yml /etc/jabber/ejabberd.yml.rpmnew
	echo 'include_config_file: "/etc/jabber/ejabberd.cfg"' > /etc/jabber/ejabberd.yml || :
fi

# post action postponed here
%service ejabberd restart "ejabberd server"
%systemd_post %{name}.service

%systemd_trigger %{name}.service

%files
%defattr(644,root,root,755)
%doc sql _doc/*
%attr(755,root,root) %{_sbindir}/*
%attr(640,root,jabber) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jabber/ejabberd-inetrc
%attr(640,root,jabber) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jabber/ejabberd.yml
%attr(640,root,jabber) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jabber/ejabberdctl.cfg
# legacy config may still be there
%attr(640,root,jabber) %ghost %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/jabber/ejabberd.cfg
%attr(770,root,jabber) /var/log/%{name}
%attr(770,root,jabber) /var/log/archive/%{name}
%if %{with logdb}
%exclude %{_libdir}/ejabberd/ebin/mod_logdb*
%endif
%{_libdir}/ejabberd
%dir %attr(770,root,jabber) /var/lib/ejabberd
%ghost %attr(400,jabber,jabber) %ghost %config(noreplace) %verify(not md5 mtime size) /var/lib/ejabberd/.erlang.cookie
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%{systemdunitdir}/%{name}.service
/etc/logrotate.d/%{name}

%if %{with logdb}
%files logdb
%defattr(644,root,root,755)
%{_libdir}/ejabberd/ebin/mod_logdb*
%endif
%changelog
* Wed Sep 30 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ejabberd.git;a=log;h=master

* Wed Sep 30 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> e9ba386
- up to 15.09

* Wed Jul 29 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> c152f85
- up to 15.07

* Tue Jul 14 2015 Jan Rękorajski <baggins@pld-linux.org> e2cb632
- release 2 (by relup.sh)

* Mon Apr 27 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> a306e2a
- needs erlang >= R16B03

* Mon Apr 27 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> f2bb2ec
- up to 15.04

* Wed Mar 25 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 8311848
- up to 15.03

* Tue Feb 17 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> b23120d
- up to 15.02

* Wed Dec 17 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 9a49bff
- up to 14.12

* Wed Oct 15 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 26c7f26
- stop kindly

* Wed Oct 15 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 95eb057
- set HOME to /home/services/jabber; otherwise ejabberd tries to access /root/.erlang.cookie

* Wed Oct 15 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> eb1d433
- run commands using su with /bin/sh shell (intead of /bin/false); rediff patch

* Wed Oct 15 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 2722a38
- same for logrotate, don't run ejabberdctl from run

* Tue Oct 14 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 43ef433
- rel 2; don't run ejabberd from root

* Tue Aug 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 78cfe19
- md5 fix

* Tue Aug 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 6a8ab62
- fix path

* Tue Aug 26 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c6f5b58
- up to 14.07

* Thu May 08 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> b16b585
- back to old stopping method but print errors on failure

* Wed May 07 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 33af212
- rel 5; small fix in mod_logdb

* Tue May 06 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> c1d4ec6
- rel 4; but set proper subsys lock

* Tue May 06 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> a778ff6
- rel 3; run all command via daemon(), so limits gets applied correctly and we don't hit: File operation error: emfile.

